import { Node } from './node';
export declare type TStatNumber = number | BigInt;
/**
 * Statistics about a file/directory, like `fs.Stats`.
 */
export declare class Stats {
    static build(node: Node, bigint?: boolean): Stats;
    uid: TStatNumber;
    gid: TStatNumber;
    rdev: TStatNumber;
    blksize: TStatNumber;
    ino: TStatNumber;
    size: TStatNumber;
    blocks: TStatNumber;
    atime: Date;
    mtime: Date;
    ctime: Date;
    birthtime: Date;
    atimeMs: TStatNumber;
    mtimeMs: TStatNumber;
    ctimeMs: TStatNumber;
    birthtimeMs: TStatNumber;
    dev: TStatNumber;
    mode: TStatNumber;
    nlink: TStatNumber;
    private _checkModeProperty;
    isDirectory(): boolean;
    isFile(): boolean;
    isBlockDevice(): boolean;
    isCharacterDevice(): boolean;
    isSymbolicLink(): boolean;
    isFIFO(): boolean;
    isSocket(): boolean;
}
export default Stats;
