"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CompilerTask = void 0;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

/**
 * compiler build task. Allows to compile components during component build.
 */
class CompilerTask {
  constructor(extensionId) {
    this.extensionId = extensionId;
  }

  execute(context) {
    return (0, _bluebird().coroutine)(function* () {
      const compilerInstance = context.env.getCompiler();
      return compilerInstance.compileOnCapsules(context);
    })();
  }

}

exports.CompilerTask = CompilerTask;