import { BitId } from '../../../bit-id';
export declare class DependencyId extends BitId {
}
export declare class Dependency {
    id: DependencyId;
    constructor(id: DependencyId);
}
export declare class PackageDependency extends Dependency {
}
export declare class ComponentDependency extends Dependency {
}
export declare class DependencyList extends Array<Dependency> {
    get packages(): PackageDependency[];
    get components(): ComponentDependency[];
    static fromArray(dependencies: Dependency[]): DependencyList;
}
export declare class Dependencies {
    runtime: DependencyList;
    dev: DependencyList;
    peer: DependencyList;
    constructor(runtime: DependencyList, dev: DependencyList, peer: DependencyList);
    private getByEnvironment;
    computeDev(): DependencyList;
    computeRuntime(): DependencyList;
}
