import { Graph } from 'cleargraph';
import { Graph as LegacyGraph } from 'graphlib';
import { Component } from '../../component';
import { Dependency } from '../dependency';
import { Workspace } from '../../workspace';
import { ComponentFactory } from '../../component';
import { DuplicateDependency } from '../duplicate-dependency';
export declare const DEPENDENCIES_TYPES: string[];
declare type Node = {
    id: string;
    node: Component;
};
declare type Edge = {
    sourceId: string;
    targetId: string;
    edge: Dependency;
};
export declare class ComponentGraph extends Graph<Component, Dependency> {
    versionMap: Map<string, {
        allVersionNodes: string[];
        latestVersionNode: string;
    }>;
    constructor(nodes?: Node[], edges?: Edge[]);
    static buildFromLegacy(legacyGraph: LegacyGraph, componentFactory: ComponentFactory): ComponentGraph;
    static build(workspace: Workspace, componentFactory: ComponentFactory): Promise<ComponentGraph>;
    findDuplicateDependencies(): Map<string, DuplicateDependency>;
    buildFromCleargraph(graph: Graph<Component, Dependency>): ComponentGraph;
    _calculateVersionMap(): Map<string, {
        allVersionNodes: string[];
        latestVersionNode: string;
    }>;
}
export {};
