/// <reference types="react" />
import { Insight, InsightResult, RawResult } from '../insight';
import { GraphBuilder, VersionSubgraph } from '../../graph';
export declare const INSIGHT_NAME = "duplicate dependencies";
declare type Dependent = {
    id: string;
    usedVersion: string;
};
declare type FormattedEntry = {
    dependencyId: string;
    latestVersion: string;
    dependents: {
        id: string;
        usedVersion: string;
    }[];
};
export default class DuplicateDependencies implements Insight {
    name: string;
    description: string;
    graphBuilder: GraphBuilder;
    constructor(graphBuilder: GraphBuilder);
    _runInsight(): Promise<RawResult>;
    _formatData(data: any): FormattedEntry[];
    _getDependents(priorVersions: VersionSubgraph[]): Dependent[];
    _renderData(data: FormattedEntry[]): JSX.Element;
    run(): Promise<InsightResult>;
}
export {};
