/// <reference types="react" />
import { Command, CommandOptions } from '../cli';
import { IsolatorExtension } from './isolator.extension';
import CapsuleList from './capsule-list';
declare type CreateOpts = {
    baseDir?: string;
    alwaysNew: boolean;
    id: string;
    installPackages: boolean;
};
export declare class CapsuleCreateCmd implements Command {
    private isolator;
    name: string;
    description: string;
    shortDescription: string;
    group: string;
    private: boolean;
    alias: string;
    options: CommandOptions;
    constructor(isolator: IsolatorExtension);
    create([componentIds]: [string[]], { baseDir, alwaysNew, id, installPackages }: CreateOpts): Promise<CapsuleList>;
    render([componentIds]: [string[]], opts: CreateOpts): Promise<JSX.Element>;
    json([componentIds]: [string[]], opts: CreateOpts): Promise<any>;
}
export {};
