"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ScopeNotFound = void 0;

function _cli() {
  const data = require("../../cli");

  _cli = function () {
    return data;
  };

  return data;
}

class ScopeNotFound extends _cli().PaperError {
  constructor(scopePath) {
    super(generateMessage(scopePath));
    this.scopePath = scopePath;
  }

  report() {
    return this.message;
  }

}

exports.ScopeNotFound = ScopeNotFound;

function generateMessage(scopePath) {
  if (scopePath) {
    return `scope not found at ${scopePath}`;
  }

  return 'scope not found';
}