import LegacyScope from '../../scope/scope';
import { IsolatorExtension } from '../isolator';
export declare type PackResult = {
    pkgJson: Record<any, string>;
    tarPath: string;
};
export declare type PackOptions = {
    outDir?: string;
    prefix?: boolean;
    override?: boolean;
    keep?: boolean;
    useCapsule?: boolean;
};
export declare class Packer {
    private isolator;
    private scope?;
    options: PackOptions;
    constructor(isolator: IsolatorExtension, scope?: LegacyScope | undefined);
    packComponent(componentId: string, scopePath: string | undefined, options: PackOptions): Promise<PackResult>;
    private packLegacy;
    private packUsingCapsule;
    private runNpmPack;
}
