"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.docsTemplate = docsTemplate;

function docsData(component) {
  var _component$state$stor;

  return ((_component$state$stor = component.state.store.findExtension('@teambit/docs')) === null || _component$state$stor === void 0 ? void 0 : _component$state$stor.data) || {};
}

function toIdentifier(name) {
  return name.replace('/', '$');
}

function docsTemplate(components) {
  const withDocs = components.filter(component => docsData(component).filepath);
  return `import { addDocs } from '../docs';
${withDocs.map(component => {
    return `import ${toIdentifier(component.id.name)} from '${docsData(component).filepath}';\n`;
  }).join('')}

addDocs([
${withDocs.map(component => `${toIdentifier(component.id.name)},\n`).join('')}
]);
`;
}