import { ComponentWithDependencies } from '../scope';
import Component from '../consumer/component/consumer-component';
import { Dependencies } from '../consumer/component/dependencies';
import Consumer from '../consumer/consumer';
import { PathOsBased } from '../utils/path';
import LinkFile from './link-file';
import BitMap from '../consumer/bit-map';
import DataToPersist from '../consumer/component/sources/data-to-persist';
declare function getIndexFileName(mainFile: string): string;
declare function getComponentLinks({ consumer, component, dependencies, createNpmLinkFiles, bitMap }: {
    consumer?: Consumer | null | undefined;
    component: Component;
    dependencies: Component[];
    createNpmLinkFiles: boolean;
    bitMap: BitMap;
}): DataToPersist;
declare function getComponentsDependenciesLinks(componentDependencies: ComponentWithDependencies[], consumer: Consumer | null | undefined, createNpmLinkFiles: boolean, bitMap: BitMap): DataToPersist;
declare function getEntryPointsForComponent(component: Component, consumer: Consumer | null | undefined, bitMap: BitMap): LinkFile[];
declare function getEntryPointForAngularComponent(component: Component, consumer: Consumer | null | undefined, bitMap: BitMap): LinkFile | null | undefined;
declare function getLinksByDependencies(targetDir: PathOsBased, component: Component, dependencies: Dependencies, consumer: Consumer | null | undefined, bitMap: BitMap, componentWithDependencies?: ComponentWithDependencies): Promise<LinkFile[]>;
export { getComponentLinks, getEntryPointsForComponent, getComponentsDependenciesLinks, getIndexFileName, getLinksByDependencies, getEntryPointForAngularComponent };
