"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getExtension = getExtension;
exports.getTemplate = getTemplate;
exports.pluginType = void 0;

function _ramda() {
  const data = _interopRequireDefault(require("ramda"));

  _ramda = function () {
    return data;
  };

  return data;
}

const pluginType = 'file-type';
exports.pluginType = pluginType;

function getExtension() {
  return 'st.css';
}

function getTemplate(importSpecifiers) {
  let stNamed = '';

  if (importSpecifiers && importSpecifiers.length) {
    const specifiers = importSpecifiers.map(importSpecifier => {
      const mainFile = _ramda().default.path(['importSpecifier', 'mainFile'], importSpecifier) || _ramda().default.path(['importSpecifier', 'importSpecifiers', 'mainFile'], importSpecifier);

      return mainFile;
    }).join(', ');
    stNamed = `-st-named: ${specifiers};`;
  }

  return `:import { 
    -st-from: "{filePath}.st.css"; 
    ${stNamed}
}`;
}